
;=======[ SUBROUTINE ]============================
; Write Ladle text
;-------------------------------------------------
; Parameters:
; DS:SI - seg:ofs(Wijet)
@Focus\; 0FFh is active, 000h is passive
	=	-08h 
;-------------------------------------------------
@Routine_private\
	Ldl_Write_Text
	push	BX
	push	CX
	push	DX
	push	AX
	;-----------------------------------------
	mov	CX,(Wijet PTR [SI])\
		.Wijet_Total; .  
	stc
	jcxz	$exit
	call	Ldl_Get_Capacity
	mov	DX,AX
	mov	BX,(Wijet PTR [SI])\
		.Wijet_Glint
	sub	BX,(Wijet PTR [SI])\
		.Wijet_Base
	jc	$less
	cmp  	BX,DX
	jae	$greater
	jmp\
	short	$tail
	;-----------------------------------------
$less:
	add	(Wijet PTR [SI])\
		.Wijet_Base,BX
	mov	AX,BX
	jmp\
	short	$tail
	;-----------------------------------------
$greater:
	mov	AX,BX
	sub	AX,DX
	inc	AX
	add	(Wijet PTR [SI])\
		.Wijet_Base,AX
	;-----------------------------------------
$tail:
	;  窠 ⠭ ᯫ뢥 ᫥
	; ᪠ ண  ⫠
	; ⮡  뫮 ਥ஢
	int	3
	mov	CX,DX
$loop:
	mov	BX,DX
	sub	BX,CX
	mov	AX,[BP+@Focus]
	call	Ldl_Write_Slice
	loop	$loop
	clc
	;-----------------------------------------
$exit:
	pop	AX
	pop	DX
	pop	CX
	pop	BX
@Routine_end

;=======[ SUBROUTINE ]============================
; Get capacity
;-------------------------------------------------
; Parameters:
;-------------------------------------------------
@Service_private\
	Ldl_Get_Capacity
	push	ES
	push	DI
	;-----------------------------------------
	call	Ldl_Seek_Style
	;᫥ ES:DI 㪠뢠  ࠬ ⨫
	;-----------------------------------------
	mov	AX,ES:(Ladle PTR [DI])\
		.Ladle_Symbol_Quantity
	;᫥  AL ਭ   AH  
	mov	DX,AX
	mul	AH
	;  ३ 
	;-----------------------------------------
$exit:
	pop	DI
	pop	ES
@Service_end

;=======[ SUBROUTINE ]============================
; Locate Slice in Ladle
;-------------------------------------------------
; Parameters:
; AX - glint
; BX - ordinal
;-------------------------------------------------
@Service_private\
	Ldl_Locate_Slice
	push	ES
	push	DI
	push	CX
	push	DX
	;-----------------------------------------
	mov	CX,AX
	call	Ldl_Seek_Style
	;-----------------------------------------
	mov	DX,(Wijet PTR [SI])\
		.Wijet_Coords
	mov	AX,ES:(Ladle PTR [DI])\
		.Ladle_Coords
	add	DL,AL
	add	DH,AH
	;-----------------------------------------
	mov	AX,BX
	div	ES: BYTE PTR (Ladle PTR [DI])\
		.Ladle_Symbol_Quantity
	xchg	AL,AH
	add	AL,DL
	add	AH,DH
	;-----------------------------------------
	IF	@Alone
@P_Locate\
		AX
@Call_far\
	Ladle_dso,@Set_AX_Coords_ID
	ELSE	
@Locate\
		AX
	ENDIF
	;-----------------------------------------
	cmp	BX,CX
	jne	$exit
	call	ES:(Ladle PTR [DI])\
		.Ladle_Method_Cursor
	;-----------------------------------------
$exit:	
	pop	DX
	pop	CX
	pop	DI
	pop	ES
@Service_end

;=======[ SUBROUTINE ]============================
; Measure Slice
;-------------------------------------------------
; Return:
; AX = length()
; DX = volume()
;-------------------------------------------------
; Parameters:
; AX - length()
;-------------------------------------------------
@Service_private\
	Ldl_Measure_Slice
	push	ES
	push	DI
	;-----------------------------------------
	mov	DX,AX
	call	Ldl_Seek_Style
	;-----------------------------------------
	div	ES: BYTE PTR (Ladle PTR [DI])\
		.Ladle_Symbol_Quantity
	or	AH,AH
	jz	$skip
	inc	AL
$skip:
	mul	ES: BYTE PTR (Ladle PTR [DI])\
		.Ladle_Symbol_Quantity
	xchg	AX,DX
	;-----------------------------------------
	pop	DI
	pop	ES
@Service_end

;=======[ SUBROUTINE ]============================
; Find Next EOL
; 頥 ⢮ ᨬ   
; ᫥饣 EOL  ࠣ  
; 㪠 ࠧ (volume)
;-------------------------------------------------
; Return:
; AX = length()
; DX = volume()
;-------------------------------------------------
; Parameters:
; AX - base
; DX - volume
;-------------------------------------------------
@Service_private\
	Ldl_Next_EOL
	push	DS
	push	SI
	push	CX
	;-----------------------------------------
	lds	SI,(Wijet PTR [SI])\
		.Wijet_Stuff_Address
	;㦠    ⥪⮬  DS:SI
	add	SI,AX
	mov	CX,DX
	mov	DX,SI
	inc	SI
	;-----------------------------------------
$loop:
	dec	SI
	cld
	lodsw
	cmp	AX,0A0Dh
	je	$ready
	or	AL,AL
	loopnz	$loop
	;-----------------------------------------
	dec	SI
$ready:
	lea	AX,[SI]
	sub	AX,DX
	;-----------------------------------------
	pop	CX
	pop	SI
	pop	DS
@Service_end

;=======[ SUBROUTINE ]============================
; Write Slice in Ladle
;-------------------------------------------------
; Parameters:
; BX - Ordinal
; AX - Focus
@Slice\
	=	-2
@Base\
	=	-4
@Gap\
	=	-6
@Capacity\
	=	-8
;-------------------------------------------------
@Routine_private\
	Ldl_Write_Slice
	sub	SP,8
	push	CX
	push	DX
	;-----------------------------------------
	mov	CX,AX
	;-----------------------------------------
	call	Ldl_Get_Capacity
	or	AX,AX
	jz	$exit
	mov	[BP+@Capacity],AX
	;-----------------------------------------
	mov	AX,CS:Ladle_Palette
	jcxz	$Color
	xchg	AL,AH
	;-----------------------------------------
	IF	@Alone
@P_Color\
		AX,Color
@Call_far\
	Ladle_dso,@Set_Color_ID
	ELSE
@Color
	ENDIF
	;-----------------------------------------
	xor	AX,AX
	mov	[BP+@Base],AX
	mov	[BP+@Gap],AX
	mov	[BP+@Slice],AX
	;-----------------------------------------
$loop:
	mov	AX,(Wijet PTR [SI])\
		.Wijet_Base
	add	AX,[BP+@Base]
	mov	DX,[BP+@Capacity]
	sub	DX,[BP+@Slice]
	call	Ldl_Next_EOL
	;-----------------------------------------
	call	Ldl_Measure_Slice
	add	[BP+@Slice],DX
	sub	DX,AX
	add	[BP+@Base],AX
	;-----------------------------------------
	mov	AX,(Wijet PTR [SI])\
		.Wijet_Glint
	sub	AX,(Wijet PTR [SI])\
		.Wijet_Base
	add	AX,[BP+@Gap]
	call	Ldl_Locate_Slice
	;-----------------------------------------
	cmp	BX,[BP+@Slice]
	jb	$write
	add	[BP+@Gap],DX
	jmp	$loop
	;-----------------------------------------
$write:
	mov	AX,[BP+@Base]
	sub	BX,[BP+@Gap]
	call	Ldl_Get_Symbol
	;-----------------------------------------
	IF	@Alone
@P_Out_One\
		AL
@Call_far\
	Ladle_dso,@Out_AL_Symbol_ID
	ELSE
@Out_One
	ENDIF
	;-----------------------------------------
$exit:
	pop	DX
	pop	CX
@Routine_end

;=======[ SUBROUTINE ]============================
; Get Slice Symbol
;-------------------------------------------------
; Parameters:
; AX - bound
; BX - ordinal
;-------------------------------------------------
@Service_private\
	Ldl_Get_Symbol
	cmp	BX,AX
	jl	$load
	;-----------------------------------------
	push	ES
	push	DI
	;-----------------------------------------
	call	Ldl_Seek_Style
	mov	AL,ES:(Ladle PTR [DI])\
		.Ladle_Space_Symbol
	pop	DI
	pop	ES
	;-----------------------------------------
	jmp\
	short	$exit
	;-----------------------------------------
$load:
	push	DS
	push	SI
	;-----------------------------------------
	mov	AX,BX
	add	AX,(Wijet PTR [SI])\
		.Wijet_Base
	lds	SI,(Wijet PTR [SI])\
		.Wijet_Stuff_Address
	add	SI,AX
	cld
	lodsb
	;-----------------------------------------
	pop	SI
	pop	DS
	;-----------------------------------------
$exit:
@Service_end

